=== debian/changelog ===
rawtherapee (4.2-4) unstable; urgency=medium

  * Add patch/05_fix_build_due_to_unsigned_char.patch:
    - Fix build with C++11 as char is unsigned on some architectures.
      Thanks Gert Wollny for the fix.

 -- Philip Rinn <rinni@inventati.org>  Wed, 04 Nov 2015 16:58:31 +0100

rawtherapee (4.2-3) unstable; urgency=medium

  * Add patch debian/patches/04_fix_build_with_c++11.patch:
    - Fix build with C++11
  * Build with C++11 as glibmm2.4 >= 2.46.1 requires that.
  * Add patch debian/patches/03_fix_build_with_new_sigc++.patch:
    - Fix build with sigc++ >= 2.5.2
  * Remove menu file due to tech-ctte decision on #741573.

 -- Philip Rinn <rinni@inventati.org>  Tue, 03 Nov 2015 18:00:21 +0100

rawtherapee (4.2-2) unstable; urgency=high

  * debian/control: Fix typo in Vcs-Git field
  * Add patch debian/patches/02-fix_CVE-2015-3885.patch:
    - Fix dcraw imput sanitization errors (CVE-2015-3885)

 -- Philip Rinn <rinni@inventati.org>  Thu, 14 May 2015 17:41:15 +0200

rawtherapee (4.2-1) unstable; urgency=medium

  * New upstream release:
    - Location of cache and config folder changed again, see NEWS.Debian.
  * Add patch debian/patches/01-fix_build_race-condition.patch:
    - cherry-picked from upsream as build _sometimes_ fails without
  * Bump Standards-Version to 3.9.6 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Sun, 26 Oct 2014 14:00:34 +0200

rawtherapee (4.1-1) unstable; urgency=medium

  * New upstream release:
    - Documentation is removed so we don't need to repack the source anymore.
    - Location of cache and config folder changed. See NEWS.Debian for details. 
  * Drop patch debian/patches/01-AboutThisBuild.patch.

 -- Philip Rinn <rinni@inventati.org>  Sun, 6 Jul 2014 13:14:54 +0200
