=== debian/control ===
Source: rawtherapee
Section: graphics
Priority: optional
Maintainer: Philip Rinn <rinni@inventati.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.6), g++ (>= 4:4.7), imagemagick,
 libbz2-dev, libexiv2-dev (>= 0.19), libexpat1-dev (>= 2.1.0), libtiff-dev,
 libfftw3-dev (>= 3.2.2), libgtk2.0-0 (>=2.24.18), libgtkmm-2.4-dev (>= 2.22),
 libiptcdata0-dev, libjpeg-dev, liblcms2-dev, libpng-dev, libsigc++-2.0-dev,
 libcanberra-gtk-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/rawtherapee.git
Vcs-Git: git://anonscm.debian.org/collab-maint/rawtherapee.git
Homepage: http://www.rawtherapee.com

Package: rawtherapee
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, rawtherapee-data (= ${source:Version})
Description: raw image converter and digital photo processor
 RawTherapee is an advanced program for developing raw photos and for processing
 non-raw photos. It is non-destructive, makes use of OpenMP, supports all the
 cameras supported by dcraw and carries out its calculations in a high precision
 32bit floating point engine. RawTherapee supports JPEG, PNG, and TIFF as output
 format for processed photos.

Package: rawtherapee-data
Architecture: all
Depends: ${misc:Depends}
Recommends: rawtherapee (= ${source:Version})
Replaces: rawtherapee (<< 4.0.9)
Breaks: rawtherapee (<< 4.0.9)
Description: raw image converter and digital photo processor (data files)
 RawTherapee is an advanced program for developing raw photos and for processing
 non-raw photos. It is non-destructive, makes use of OpenMP, supports all the
 cameras supported by dcraw and carries out its calculations in a high precision
 32bit floating point engine. RawTherapee supports JPEG, PNG, and TIFF as output
 format for processed photos.
 .
 This package contains the data files.
